<?php

/*
Plugin Name: Remote Images Grabber
Plugin URI: http://plus.eto-ya.com/remote-images-grabber
Description: Fetches images on the list of URLs, save them to the blog media directory, and attaches to the appointed post.
Author: Andrey K.
Version: 0.2
Author URI: http://andrey.eto-ya.com/

*/

/*  Copyright 2009 Andrey K. (email: v5@bk.ru, URL: http://andrey.eto-ya.com/)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

load_plugin_textdomain('rigr', 'wp-content/plugins/remote-images-grabber');

add_action('admin_menu', 'rigr_add_menu');

function rigr_add_menu() {
	add_media_page( __('Images Grabber'), __('Images Grabber'), 'manage_options', 'remote_images_grabber', $func = 'rigr_manager' );

}

function rigr_manager() {

	global $wpdb;

	if ( 'POST'== $_SERVER['REQUEST_METHOD'] )
	{
		$rigr_attach_to= $_POST['rigr_attach_to'];
		$rigr_attach_to= (int)$rigr_attach_to;

		$post= $wpdb->get_row("SELECT ID, post_date FROM $wpdb->posts WHERE ID=$rigr_attach_to", ARRAY_A);

		if ( !$post ) {
			$rigr_attach_to= 0;
		}
		
		$page_with_links= $_POST['rigr_page_with_links'];
	
		if ( $page_with_links!='' )
		{
			$tmpname= tempnam('/tmp', '');
			$headers= wp_get_http($page_with_links, $tmpname);

			if ( $headers['response'] && ( $headers['response'] != '200' ) )
			{
				echo '<p>Incorrect: ',$page_with_links,' - response ',$headers['response'], ', should be 200.</p>';
				$urls= array();
			}
			else
			{
				$s= file_get_contents($tmpname);
				echo '<p>',$page_with_links,' - ',strlen($s), ' bytes</p>';
				$s= wp_kses($s, array('a'=>array('href'=>1)) );

				preg_match_all('/http:\/\/[a-z0-9\.\/_\?\&-]+/is', $s, $allurls);

				foreach ($allurls[0] as $u)
				{
					if ( preg_match('/(jpg|jpeg|gif|png)/i', $u) )
					$urls[]= $u;
				}
			}
			$rigr_tmp_list= $urls;
			unlink($tmpname);
		}
		else
		{
			$rigr_tmp_list= explode("\n", $_POST['rigr_list']);
		}

		foreach ($rigr_tmp_list as $k=>$v )
		{
			$v= trim($v);
			if ( strpos(' '.$v, 'http://')==1 ) {
				$rigr_list[]= $v;
			}
		}

		foreach ($rigr_list as $k=>$v )
		{
			usleep(300000);
			$res[$k]= rigr_fetch_remote_file($post, $v);

			if ( is_object($res[$k]) && $res[$k]->errors  /* to do: handle object WP_Error */ ) {
				$out= $res[$k]->errors;
				echo '<p>',$v, ' - '; print_r($out);
				echo '</p>';
				continue;
			}
			
			if ( !empty($_POST['rigr_post_title']) ) {
				$title= wp_kses($_POST['rigr_post_title'], array()).(($k==0)?'':' - '.$k);
			}
			else {
				$title= basename($res[$k]['file']);
				if ( $dotpos= strpos($title, '.') )
					$title= substr($title, 0, $dotpos);
			}
			$att= array(
				'post_status'=>'publish', 'post_parent'=> $rigr_attach_to, 'ping_status' =>'closed', 'guid'=>$res[$k]['url'], 'post_title'=> $title, 'post_mime_type'=>$res[$k]['content-type'] );


			$att_ID= wp_insert_attachment($att);

			if ( !$att_ID ) {
				echo "<br />can not create attachment for $res[$k][file]<br />";
				continue;
			}

			wp_update_attachment_metadata($att_ID, wp_generate_attachment_metadata($att_ID, $res[$k]['file']));
			update_attached_file($att_ID, $res[$k]['file']);
			echo '<p>',$v, ' - OK </p>';
		}
		

	}
?>

<div class="wrap">

<div id="icon-upload" class="icon32"></div>

<h2><?php _e('Remote Images Grabber', 'rigr'); ?></h2>

<form method="post" action="<?php bloginfo('url'); ?>/wp-admin/upload.php?page=remote_images_grabber<?php echo (int)$_GET['attach_to']?'&amp;attach_to='.(int)$_GET['attach_to']:''; ?>" name="rigr_form" id="rigr_form" >
<table style="vertical-align:top">
<tr style="vertical-align:top">
<td>

<p><?php _e('List of remote images, one URL per line:', 'rigr'); ?><br />
<textarea name="rigr_list" rows="12" cols="76"></textarea></p>

<p><?php _e('Or the URL of a page with hyperlinks to images:', 'rigr'); ?>
<input type="text" name="rigr_page_with_links" size="40" />
</p>
</td>
<td >
<p style="margin:2em 0 0 20px !important"><?php _e('File size limit', 'rigr'); ?> <input type="text" name="rigr_max_size" value="0" size="4" /> KB
<small><br />(<?php _e('Leave 0 for no limit', 'rigr'); ?>)</small>
</p>
</td>
</tr>
</table>
<p><?php _e('The post ID where images should be attached to:', 'rigr'); ?> <input type="text" name="rigr_attach_to" value="<?php echo (int)$_GET['attach_to']; ?>" size="3" />
<small><br />(<?php _e('if not set then images will be unattached', 'rigr'); ?>)</small>
</p>

<p><?php _e('The title for a file or file group:', 'rigr'); ?> <input type="text" name="rigr_post_title"  size="40" />
<small><br />(<?php _e('if not set, files names are used', 'rigr'); ?>)</small>
</p>

<p><br /><input type="submit" style="width:400px" class="button-primary" name="Submit" value=" <?php _e('Go!', 'rigr') ?> " /></p>
</form>

</div>
<?php
}

/* -- modified function from wp-admin/import/wordpress.php:~666 -- */

function rigr_fetch_remote_file($post, $url) {
		$upload = wp_upload_dir($post['post_date']);
		
		$pu= parse_url($url);
		$file_name = basename($pu['path']);

		$upload2 = wp_upload_bits( $file_name, 0, '', $post['post_date']);

		if ( $upload2['error'] ) {
			echo $upload2['error'];
			return new WP_Error( 'upload_dir_error', $upload2['error'] );
		}

		$headers = wp_get_http($url, $upload2['file']);

		if ( ! $headers ) {
			@unlink($upload2['file']);
			return new WP_Error( 'import_file_error', __('Remote server did not respond') );
		}

		if ( $headers['response'] != '200' ) {
			@unlink($upload2['file']);
			return new WP_Error( 'import_file_error', sprintf(__('Remote file returned error response %1$d %2$s'), $headers['response'], get_status_header_desc($headers['response']) ) );
		}
		elseif ( isset($headers['content-length']) && filesize($upload2['file']) != $headers['content-length'] ) {
			@unlink($upload2['file']);
			return new WP_Error( 'import_file_error', __('Remote file is incorrect size') );
		}

		$max_size = ((int)$_POST['rigr_max_size'])*1024;

		if ( !empty($max_size) && filesize($upload2['file']) > $max_size ) {
			@unlink($upload2['file']);
			return new WP_Error( 'import_file_error', sprintf(__('Remote file is too large, limit is %s'), $max_size) );
		}

		$upload2['content-type']= $headers['content-type'];
		return $upload2;

	}

?>